; Lemmings - a first look
;
; Stephan Effelsberg , b012414@mail.dvz.fh-koeln.de
; Alejandro Paz Schmidt , psys@cotelco.com.ar
;
; also see   www.dvz.fh-koeln.de/~b012414

 include "tios.h"
 include "vars.h"
 include "levels.h"
 include "attrib.h"

WalkAnim:
 incbin walker.pln	; ( 0.. 3) 4r +( 4.. 7) 4l animations
 incbin faller.pln	; ( 8..11) 4
 incbin digger.pln	; (12..19) 8
 incbin jumpin.pln	; (20..23) 4
 incbin floater.pln	; (24..31) 8
 incbin splasher.pln	; (32..39) 8
 incbin climber.pln     ; (40..47) 8r + (48..55) 8l
 incbin miner.pln	; (56..63) 8r + (64..71) 8l
 incbin builder.pln	; (72..79) 8r + (80..87) 8l
 incbin shrugger.pln    ; (88..91) 4
 incbin blocker.pln     ; (92..99) 8
 incbin bomber.pln      ; (100..107) 8	'oh no'
 incbin splasher.pln	; (108..115) 8	bomb
 incbin basher.pln	; (116..123) 8r + (124..131) 8l

 include charset2.h
quadsdta:
        incbin  quad.lib

 xdef   _main
 xdef   _comment

mvar    dc.l    0

_main:
        lea     -13896(a7),a7   ; saves room on the stack
        lea     mvar(pc),a1
        move.l  a7,(a1)
;_m1:
;        clr.w   d0                    ; to debug dont shrink it
;        tst.w   tios::kb_globals+$1C  ;
;        beq     _m1                 ;

        move.l  a7,a6   ; variables on stack

        bsr     initgr4lib        ; int and grayscale, self implementation
        beq     Exit1             ; if it fails

StartOver:

        bsr     Intro
        clr.w   curlvl(a6)        ; starts form level 0
        ;;move.w  #4,curlvl(a6)
NextLevel:
        clr.b   gstatus(a6)       ; game in progress
        bsr     extractlvl

        bsr     prescr

        bsr     InitInfo          ; the 8 boxes to the left of the screen
        clr.w   anit(a6)
MainLoop:
        tst.b   ticks(a6)
        beq     MainLoop
f0_l1:
        clr.b   ticks(a6)       ; event marker

        bsr     DoKeys
        bsr     DoLemming
        bsr     SprDispInit
        bsr     updateani
        bsr     ShowScreen      ; and ShowCross
        bsr     SprDisp
        bsr     ShowTargetName
        bsr     showvar
;;
TstQ:   
        tst.b   gstatus(a6)
        bmi     Exit
        clr.w   d1
        cmp.b   #1,gstatus(a6)
        beq     f0_l5          ; started may be stopped
        cmp.b   #3,gstatus(a6)
        beq     f0_l8

        cmp.b   #1,LemsOut(a6)
        bne     MainLoop
        move.b  #1,gstatus(a6) ; started
f0_l5:
	move.b  LemsTotal(a6),d0
	cmp.b   LemsOff(a6),d0
        bne     MainLoop
f0_l6:
        moveq   #1,d1
        clr.b   gstatus(a6)
        lea     lvldta(pc),a0
        move.w  curlvl(a6),d0
        mulu    #LLVLDTA,d0
        add.l   d0,a0
        move.b  LLemNe(a0),d0
        cmp.b   LemsIn(a6),d0
                                ; the level must be redone
        bhi     f0_l8           ; do the same level again
        addq.w  #1,curlvl(a6)
        cmp.w   #5,curlvl(a6)
        bne     NextLevel
        moveq   #2,d0
f0_l7:  bsr     tupscr          ; press ESC to start over...
        bra     StartOver
f0_l8:  bsr     tupscr
        bra     NextLevel
Exit:
        bsr     exitgr4lib      ; greyscale off and restoring int
Exit1:  lea     13896(a7),a7
        rts

; ***************************************************************************
;
; DoKeys - scans the keyboard and updates the variables

DoKeys:
        bsr     ScanKeys
f2_l4:
        move.b  KeyStat(a6),d0
        tst.b   d0
        bne     f2_l3
        move.b  #1,CursorSpeed(a6)
        bra     f2_l50
f2_l3:
	clr.b	CursorMoved(a6)
        clr.w   d1
        move.b  CursorSpeed(a6),d1

f2_l5:  btst    #3,d0 ; rigth
        beq     f2_l10
        ; derecha
        ; verifico si el puntero puede moverse (esta dentro del area visible)
        ; si no puedo moverlo verifico si puedo mover el nivel
        ;
f2_l6:  add.w   d1,XCross(a6)
        move.b  #1,CursorMoved(a6)

        cmp.w   #XMAXVIEW-8,XCross(a6)
        bge     f2_l7   ; jump if we need to move the view
        bra     f2_l10 ; !
f2_l7:  ; the level have LMAXCOLS*8 pixels, we show only XMAXVIEW pixels
        move.w  #XMAXVIEW-8,XCross(a6)
        cmp.w   #LMAXCOLS-XMAXVIEW/8,Xoff(a6)
        beq     f2_l10  ; don't move
        addq.w  #2,Xoff(a6)

f2_l10:   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        btst    #1,d0 ; left
        beq     f2_l15

f2_l11: sub.w   d1,XCross(a6)
        bpl     f2_l12
        clr.w   XCross(a6)
f2_l12: move.b  #2,CursorMoved(a6)
        ; izq
        tst.w   XCross(a6)
        beq     f2_l14
        bra     f2_l15
f2_l14: tst.w   Xoff(a6)
        beq     f2_l15  ; don't move
        subq.w  #2,Xoff(a6)

f2_l15:   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        btst    #2,d0 ; up
        beq     f2_l20

f2_l16: sub.w   d1,YCross(a6)
        bpl     f2_l17
        clr.w   YCross(a6)         ; fixes position if neg
f2_l17: move.b  #3,CursorMoved(a6)
        ; arriba
        tst.w   YCross(a6)
        bne     f2_l20
f2_l18: tst.w   Yoff(a6)
        beq     f2_l20
        subq.w  #8,Yoff(a6)

f2_l20:   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        btst    #4,d0 ; down
        beq     f2_l25

f2_l21: add.w   d1,YCross(a6)

        move.b  #4,CursorMoved(a6)
        ; abajo
        cmp.w   #YMAXVIEW-8,YCross(a6) ; if we need to move the view
        bge     f2_l22
        bra     f2_l25
f2_l22: move.w  #YMAXVIEW-8,YCross(a6)
        cmp.w   #LMAXROWS*8-YMAXVIEW,Yoff(a6)
        beq     f2_l25
        addq.w  #8,Yoff(a6)

f2_l25:
        addq.b  #3,CursorSpeed(a6)
        tst.b   CursorMoved(a6)
        bne     f2_l26
        move.b  #1,CursorSpeed(a6)
f2_l26:
        move.b  CursorSpeed(a6),d1
	cmp.b   #16,d1
	bcs     f2_l27
	move.b  #16,CursorSpeed(a6)
f2_l27:
        btst    #6,d0 ; tecla exit
        bne     f2_l99
f2_l50:
        move.w  Xoff(a6),d0
        lsl.w   #3,d0
        add.w   XCross(a6),d0   ; XCross is in pixels
        lsr.w   #1,d0           ; XCrossTrue in dpixels
        move.w  d0,XCrossTrue(a6)
        move.w  Yoff(a6),d0
        add.w   YCross(a6),d0
        move.w  d0,YCrossTrue(a6)

        move.b  KeyStat+1(a6),d1
        move.w  #7,d7
f2_l52:
        lsl.b   #1,d1
        dbcs    d7,f2_l52
        tst.b   d7                     d7 now contains f-key number 0..7 or $ff
        bmi     f2_l54
        clr.w   d2
        move.b  Command(a6),d2
        bsr     cquad   ; ClearQuad
        clr.w   d2
        move.b  d7,d2
        move.b  d2,Command(a6)
        bsr     pquad   ; PutQuad
f2_l54:
       ; check if command key (hand) is pressed
        move.b  #$80,GiveCommand(a6)          ; neg = give command to no lemming
        btst    #0,KeyStat(a6)                ; hand
        beq     f2_l56
        move.b  LemTarget(a6),GiveCommand(a6) ; give command to current target
f2_l56:
        btst    #5,KeyStat(a6)                ; clear
        beq     f2_l57
	move.b  #1,Chain(a6)
f2_l57:
        rts

f2_l99: move.b  #$ff,gstatus(a6)
        rts             ; exits to tios


; ****************************************************************************
; ****************************************************************************
;
; Lemming stuff
;
; ****************************************************************************
; ****************************************************************************
;

;
; InitLemming
;

InitLemming:
        clr.w   d0
        move.b  LemsTotal(a6),d0
        subq.b  #1,d0
        lea     LemTab(a6),a0
        lea     lvldta(pc),a1
        move.w  curlvl(a6),d1
        mulu    #LLVLDTA,d1
        add.l   d1,a1   ; a1 points to the level data

ILLoop:
        move.w  #0,(a0)+        ; LemAct
 ; The lemms will fall from the middle of the gate
        move.w  GaSpX(a6),d1    ; Start gate X
        lsl.w   #2,d1
        addq.w  #4,d1
        move.w  d1,(a0)+        ; X
        move.w  GaSpY(a6),d1    ; Start gate Y
	lsl.w	#3,d1
        move.b  #$ff,(a0)+      ; number above counter = ff inhibit
        move.b  d1,(a0)+        ; Y
        move.w  d0,d1
        addq.w  #1,d1
        move.w  d1,(a0)+        ; spawning number, 1..x
        move.w  #1,(a0)+        ; orientation: right
        dbra    d0,ILLoop
        move.w  #-1,(a0)        ; end of tab
        rts

;
; DoLemming
;

DoLemming:
 clr.b   LemCurrent(a6)
 move.b  #$80,LemTarget(a6)
 lea     LemTab(a6),a5
 
 sub.b   #1,LemSpawn(a6)
 and.b   #1,Chain(a6)

DLLoop:
 move.w  LLemAct(a5),LemAct(a6)
 move.w  LLemX(a5),LemX(a6)
 clr.w   d0
 move.b  LLemY(a5),d0
 move.w  d0,LemY(a6)
 move.w  LLemCnt(a5),LemCnt(a6)
 move.b  LLemCnt2(a5),LemCnt2(a6)
 move.b  LLemDir(a5),d0
 ext.w   d0
 move.w  d0,LemDir(a6)

 tst.w   LemAct(a6)
 bmi     DLEnd     ; end of table
 bne     DLStart   ; process this lemming
 tst.w   LemCnt(a6)
 beq     DLNext    ; 0=out of level
 tst.b   Chain(a6) ; spawn no more lemmings when chain bombing
 beq     DLSpawn
 clr.w   LemAct(a6)
 clr.w   LemCnt(a6)
 addq.b  #1,LemsOff(a6)
 bra     DLNext

DLSpawn:
 tst.b   LemSpawn(a6)
 bne     DLNext
 sub.w   #1,LemCnt(a6) ; waiting
 bne     DLNext
 move.w  #1,LemAct(a6) ; spawn lemming as faller
 addq.b  #1,LemsOut(a6)   ; @#

DLStart:
 cmp.w   #8*LMAXROWS,LemY(a6)
 bcc     DLOff
 
; check for bomb chain effect
 tst.b   Chain(a6)
 beq     DLNoChain
 bmi     DLNoChain
 tst.b   LLemTime(a5)
 bpl     DLNoChain
 cmp.b   #13,LemAct+1(a6) ; Bomber
 beq     DLNoChain
 st      Chain(a6)
 move.b  #24,LLemTime(a5)
DLNoChain:
; check for bomb command
 move.b  GiveCommand(a6),d0
 cmp.b   LemCurrent(a6),d0
 bne     DLNoBombCmd
 bsr     DLCmdFloat	; also check for float and climb
 bsr     DLCmdClimb
 tst.b   LLemTime(a5)
 bpl     DLNoBombCmd
 bsr     DLCmdBomb
 bne     DLNoBombCmd
; init bomb delay
 move.b  #24,LLemTime(a5)
DLNoBombCmd:
; decrease time and run Bomber
 move.b  LLemTime(a5),d0
 bmi     DLNoBomber
 subq.b  #1,d0
 move.b  d0,LLemTime(a5)
 bpl     DLNoBomber
 bra     DLBomb

DLNoBomber:
 lea	DLBase(pc),a0
 clr.w	d0
 move.b	LemAct+1(a6),d0
 subq.w	#1,d0
 lsl.w	#1,d0
 move.w	0(a0,d0.w),d0
 jmp	0(a0,d0.w)

DLBase:                                 ; LemAct:
	dc.w	(DLFaller-DLBase)	; 1
	dc.w	(DLWalker-DLBase)	; 2
	dc.w	(DLDigger-DLBase)	; 3
	dc.w	(DLFloater-DLBase)	; 4
	dc.w	(DLLander-DLBase)	; 5
	dc.w	(DLSplasher-DLBase)	; 6
	dc.w	(DLClimber-DLBase)	; 7
	dc.w	(DLMiner-DLBase)	; 8
	dc.w	(DLBuilder-DLBase)	; 9
	dc.w	(DLShrugger-DLBase)	; 10
	dc.w	(DLJumpInner-DLBase)	; 11
	dc.w	(DLBlocker-DLBase)	; 12
	dc.w	(DLBomber-DLBase)	; 13
	dc.w	(DLBasher-DLBase)	; 14


DLFall:
 move.b  #1,LemAct+1(a6)
 move.w  #8,LemCnt(a6)
 clr.b   LemCnt2(a6)   ; count falling steps
 bra     DLNext
DLFaller:
 btst.w  #9,LemAct(a6)
 beq     DLFa1
 cmp.b   #5,LemCnt2(a6) ; no floating for short distances
 bcc     DLFloat
DLFa1:
 move.b  GiveCommand(a6),d0
 cmp.b   LemCurrent(a6),d0
 bne     DLFa2
; bsr     DLCmdFloat
DLFa2:
 move.w  LemCnt(a6),d0
 add.b   #1,d0
 and.b   #3,d0
 add.b   #8,d0
 move.w  d0,LemCnt(a6)
 move.w  LemX(a6),d0
 add.w   #1,d0
 move.w  LemY(a6),d1
 add.b   #16,d1
 bsr     GetAttribAtXY
 cmp.b   #5,d2   ; killing
 beq     DLSplash
 bsr     TestDepth
 tst.b   d7
 beq     DLFASpl
 add.w   d7,LemY(a6)
 addq.b  #1,LemCnt2(a6)
 bra     DLNext
DLFASpl:
 cmp.b   #21,LemCnt2(a6)
 bcc     DLSplash
 bra     DLWalk



DLWalk:
 move.b  #2,LemAct+1(a6)
 clr.w   d0
 tst.w   LemDir(a6)
 bpl     DLWLI
 or.b    #4,d0
DLWLI:
 move.w  d0,LemCnt(a6)
 clr.b   LemCnt2(a6)
 bra     DLNext
DLWalker:
 ; test if walker is at exit gate
 move.w	LemX(a6),d0
 move.w	LemY(a6),d1
 add.w  #4,d1
 bsr	GetAttribAtXY
 cmp.b	#2,d2
 beq	DLJumpIn

; btst.w  #8,LemAct(a6)
; beq     DLWLNCl
; bsr     DLClimbTest
; bne     DLClimb
;DLWLNCl:
 tst.b   LemCnt2(a6) ; buffer for block command
 bne     DLWLBl
 move.b  GiveCommand(a6),d0
 cmp.b   LemCurrent(a6),d0
 bne     DLWLCount
; bsr     DLCmdFloat
; bsr     DLCmdClimb
 bsr     DLCmdDig
 beq     DLDig
 bsr     DLCmdMine
 beq     DLMine
 bsr     DLCmdBash
 beq     DLBash
 bsr     DLCmdBuild
 beq     DLBuild
; special case for Blocker, Lemming must be tile-aligned
; set LemCnt2 to remember if not
 bsr     DLCmdBlock
 bne     DLWLCount
 st      LemCnt2(a6)
DLWLBl:
 tst.b   LemCnt2(a6)
 beq     DLWLCount
 move.w  LemX(a6),d0
 and.b   #3,d0
 beq     DLBlock

DLWLCount:
 move.w  LemCnt(a6),d0
 add.b   #1,d0
 and.b   #3,d0
 tst.w   LemDir(a6)
 bpl     DLWL
 or.b    #4,d0
DLWL:
 move.w  d0,LemCnt(a6)
 move.w  LemX(a6),d0
 add.w   #1,d0
 add.w   LemDir(a6),d0
 move.w  LemY(a6),d1
 add.w   #7,d1
 bsr     GetAttribAtXY
 cmp.b   #4,d2   ; blocking
 beq     DLWRev
 add.w   #8,d1
 bsr     TestHeight1
 tst.b   d7
 bmi     DLWLClimb
 beq     DLW1
 sub.w   d7,LemY(a6)
 move.w  LemDir(a6),d6
 add.w   d6,LemX(a6)
 bra     DLNext
DLW1:
 move.w  LemX(a6),d0
 add.w   #1,d0
 add.w   LemDir(a6),d0
 move.w  LemY(a6),d1
 add.b   #16,d1
 bsr     TestDepth
 move.w  LemDir(a6),d6
 add.w   d6,LemX(a6)
 tst.b   d7
 bne     DLWDown
 bra     DLNext
DLWDown:
 cmp.b   #3,d7
 bcc     DLFall
 add.w   d7,LemY(a6)
 bra     DLNext
DLWRev:
 neg.w   LemDir(a6)
 move.w  LemDir(a6),d6
 add.w   d6,LemX(a6)
 eor.w   #4,LemCnt(a6)
 bra     DLNext
DLWLClimb:
 btst.w  #8,LemAct(a6)
 beq     DLWRev
 bra     DLClimb




DLDig:
 move.b  #3,LemAct+1(a6)
 move.w  #12,LemCnt(a6)
; if there are obstacles at the feet
 move.w  LemX(a6),d0
 move.w  LemY(a6),d1
 add.w   #15,d1
 bsr     PixClear4
; bsr     PixClear
; add.w   #1,d0
; bsr     PixClear
; add.w   #1,d0
; bsr     PixClear
; add.w   #1,d0
; bsr     PixClear
 bra     DLNext
DLDigger:
 move.b  GiveCommand(a6),d0
 cmp.b   LemCurrent(a6),d0
 bne     DLDig1
 bsr     DLCmdMine
 beq     DLMine
 bsr     DLCmdBash
 beq     DLBash
DLDig1:
 move.w  LemCnt(a6),d0
 add.b   #1,d0
 and.b   #7,d0
 add.b   #12,d0
 move.w  d0,LemCnt(a6)
 move.w  LemX(a6),d0
 add.w   #1,d0
 move.w  LemY(a6),d1
 add.b   #16,d1
 bsr     TestDepth
 cmp.w   #3,d7   ; two empty lines do not confuse the digger
 bcc     DLFall
 move.w  LemCnt(a6),d2
 and.w   #1,d2   ; dig speed, one line at every 2nd tick
 bne     DLNext
 move.w  LemX(a6),d0
 move.w  LemY(a6),d1
 add.w   #16,d1
 bsr     PixClear4
; bsr     PixClear
; add.w   #1,d0
; bsr     PixClear
; add.w   #1,d0
; bsr     PixClear
; add.w   #1,d0
; bsr     PixClear
 add.w   #1,LemY(a6)
 bra     DLNext



DLFloat:
 move.b  #4,LemAct+1(a6)
 move.w  #24,LemCnt(a6)
 bra     DLNext
DLFloater:
 move.w  LemCnt(a6),d0
 cmp.b   #28,d0   ; 24..27: open chute, 28..32 float
 bcc     DLFL1
 ; open chute
 addq.w  #1,LemCnt(a6)
 move.w  LemX(a6),d0
 add.w   #1,d0
 move.w  LemY(a6),d1
 add.b   #16,d1
 bsr     GetAttribAtXY
 cmp.b   #5,d2   ; killing
 beq     DLSplash
 bsr     TestDepth
 tst.b   d7
 beq     DLLand
 add.w   d7,LemY(a6)
 bra     DLNext
DLFL1:
 ; float
 move.w  LemCnt(a6),d0
 addq.w  #1,d0
 and.w   #3,d0
 add.w   #28,d0
 move.w  d0,LemCnt(a6)
 move.w  LemX(a6),d0
 add.w   #1,d0
 move.w  LemY(a6),d1
 add.b   #16,d1
 bsr     GetAttribAtXY
 cmp.b   #5,d2   ; killing
 beq     DLSplash
 bsr     TestDepth
 tst.b   d7
 beq     DLFLSpl
 addq.w  #1,LemY(a6)
 bra     DLNext
DLFLSpl:
 cmp.b   #21,LemCnt2(a6)
 bcc     DLSplash
 bra     DLLand



DLLand:
 move.b  #5,LemAct+1(a6)
 move.w  #27,LemCnt(a6)
 bra     DLNext
DLLander:
 move.w  LemCnt(a6),d0
 ; close chute
 subq.w  #1,d0
 cmp.w   #23,d0
 beq     DLWalk
 move.w  d0,LemCnt(a6)
 bra     DLNext



DLSplash:
 move.b  #6,LemAct+1(a6)
 move.w  #32,LemCnt(a6)
 bra     DLNext
DLSplasher:
 move.w  LemCnt(a6),d0
 addq.w  #1,d0
 cmp.w   #40,d0
 beq     DLOff 
 move.w  d0,LemCnt(a6)
 bra     DLNext



;DLClimbTest:
; move.w  LemX(a6),d0
; sub.w   #1,d0          ; for left dir
; tst.w   LemDir(a6)
; bmi     DLCLT1
; add.w   #4,d0
;DLCLT1:
; move.w  LemY(a6),d1
; add.b   #15,d1
; bsr     TestHeight
; tst.b   d7
; bmi     DLClimbYes
;DLClimbNo:
; cmp.b   d0,d0   ; Z=1
;DLClimbYes:
; ; Z=0 instead (d7 is negative)
; rts
 
DLClimb:
 subq.w  #2,LemX(a6)
 move.b  #7,LemAct+1(a6)
 move.w  #40,LemCnt(a6)   ; right ani
 tst.w   LemDir(a6)
 bpl     DLNext
 add.w   #8,LemCnt(a6)
 addq.w  #3,LemX(a6)
 bra     DLNext
DLClimber:
 move.b  GiveCommand(a6),d0
 cmp.b   LemCurrent(a6),d0
 bne     DLCLAni  
; bsr     DLCmdFloat
DLCLAni:
; animation
 move.w  LemCnt(a6),d0
 add.b   #1,d0
 and.b   #7,d0
 tst.w   LemDir(a6)
 bpl     DLCLR
 add.b   #8,d0
DLCLR:
 add.b   #40,d0
 move.w  d0,LemCnt(a6)
; test for next wall pixel
 move.w  LemX(a6),d0
 sub.w   #1,d0          ; for left dir
 tst.w   LemDir(a6)
 bmi     DLCL1
 add.w   #5,d0
DLCL1:
 move.w  LemY(a6),d1
 add.w   #11,d1
 bsr     PixTest
 beq     DLCLWalk       ; no wall, walk
; test for ledge
 sub.w   #3,d1
 sub.w   LemDir(a6),d0
 bsr     PixTest
 bne     DLCLFall       ; projection
; climb
; move.w  LemCnt(a6),d0
; and.w   #1,d0
; bne     DLNext
 sub.w   #1,LemY(a6)
 bra     DLNext
DLCLWalk:
 sub.w   #3,LemY(a6)
 move.w  LemDir(a6),d0
 asl.w   #1,d0
 add.w   d0,LemX(a6)
 bra     DLWalk
DLCLFall:
 neg.w   LemDir(a6)
 bra     DLFall



DLMine:
 move.b  #8,LemAct+1(a6)
; if there are obstacles at the feet
 move.w  LemX(a6),d0
 move.w  LemY(a6),d1
 add.w   #14,d1
 add.w   #1,d0
 add.w   LemDir(a6),d0
 bsr     PixClear
 add.w   #1,d0
 bsr     PixClear
 add.w   #1,d1
 bsr     PixClear
 sub.w   #1,d0
 bsr     PixClear
 move.w  #56,LemCnt(a6)
 tst.w   LemDir(a6)
 bpl     DLNext
 add.w   #8,LemCnt(a6)
 bra     DLNext
DLMiner:
 move.b  GiveCommand(a6),d0
 cmp.b   LemCurrent(a6),d0
 bne     DLM1
 bsr     DLCmdDig
 beq     DLDig
 bsr     DLCmdBash
 beq     DLBash
DLM1:
 move.w  LemCnt(a6),d0
 add.b   #1,d0
 and.b   #7,d0
 add.b   #56,d0
 tst.w   LemDir(a6)
 bpl     DLM2
 add.w   #8,d0
DLM2:
 move.w  d0,LemCnt(a6)
 and.w   #7,d0   ; mine at specific animation step
 cmp.w   #3,d0
 bne     DLNext
 tst.w   LemDir(a6)
 bmi     DLMLeft
 move.w  LemX(a6),d0
 add.w   #3,d0
 move.w  LemY(a6),d1
 add.b   #16,d1
 bsr     TestDepth
 cmp.w   #2,d7   ; one empty line does not confuse the miner
 bcc     DLFall
 move.w  LemCnt(a6),d2
; mine these pixels
;    x+2 -v
; y+16 -> 11223344
;           776655
;             88
 move.w  LemX(a6),d0
 move.w  LemY(a6),d1
 add.w   #16,d1
 add.w   #2,d0
 bsr     PixClear4
 add.w   #1,d1
 add.w   #1,d0
 bsr     PixClear
 add.w   #1,d0
 bsr     PixClear
 add.w   #1,d0
 bsr     PixClear
 sub.w   #1,d0
 add.w   #1,d1
 bsr     PixClear
 add.w   #2,LemY(a6)
 add.w   #1,LemX(a6)
 bra     DLNext
DLMLeft:
 move.w  LemX(a6),d0
 sub.w   #1,d0
 move.w  LemY(a6),d1
 add.b   #16,d1
 bsr     TestDepth
 cmp.w   #2,d7   ; one empty line does not confuse the miner
 bcc     DLFall
 move.w  LemCnt(a6),d2
; mine these pixels
;    x-2 -v
; y+16 -> 11223344
;         776655
;           88
 move.w  LemX(a6),d0
 move.w  LemY(a6),d1
 add.w   #16,d1
 sub.w   #2,d0
 bsr     PixClear4
 add.w   #1,d1
 bsr     PixClear
 add.w   #1,d0
 bsr     PixClear
 add.w   #1,d0
 bsr     PixClear
 sub.w   #1,d0
 add.w   #1,d1
 bsr     PixClear
 add.w   #2,LemY(a6)
 sub.w   #1,LemX(a6)
 bra     DLNext



DLBuild:
 move.b  #16,LemCnt2(a6)   ; number of steps
 move.b  #9,LemAct+1(a6)
 move.w  #72,LemCnt(a6)
 tst.w   LemDir(a6)
 bpl     DLNext
 add.w   #8,LemCnt(a6)
 bra     DLNext
DLBuilder:
 move.w  LemCnt(a6),d0
 add.b   #1,d0
 and.b   #7,d0
 add.b   #72,d0
 tst.w   LemDir(a6)
 bpl     DLBld1
 add.w   #8,d0
DLBld1:
 move.w  d0,LemCnt(a6)
 and.w   #7,d0
 cmp.w   #0,d0 ; obsolete
 bne     DLBld2
; test if dir must be reverted
 move.w  LemX(a6),d0
 add.w   #1,d0
 move.w  LemY(a6),d1
 add.w   #14,d1
 bsr     PixTest
 bne     DLBldSR
 add.w   LemDir(a6),d0
 add.w   #1,d1
 bsr     PixTest
 beq     DLNext
; revert
 move.w  LemDir(a6),d0
 add.w   d0,LemX(a6)
 neg.w   LemDir(a6)
 bra     DLNext
; shrug and revert
DLBldSR:
 neg.w   LemDir(a6)
 bra     DLShrug
DLBld2:
 cmp.w   #4,d0   ; build at specific animation step
 bne     DLNext
 move.w  LemX(a6),d0
 tst.w   LemDir(a6)
 bmi     DLBldLeft
DLBldRight:
 add.w   #2,d0
DLBldLeft:
 lsl.w   #1,d0
 btst.b  #0,LemCnt2(a6) ; use single pixels to build step
 beq     DLBld3
 add.w   LemDir(a6),d0
 move.w  LemDir(a6),d1
 add.w   d1,LemX(a6) ; X is adjusted every 2nd pixel (= every dpixel)
DLBld3:
 move.w  LemY(a6),d1
 add.w   #15,d1   ; to Lemming's feet
 bsr     PixSetS
 add.w   #1,d0
 bsr     PixSetS
 sub.w   #1,LemY(a6)
 sub.b   #1,LemCnt2(a6)
 beq     DLShrug
 bra     DLNext



DLShrug:
 move.b  #10,LemAct+1(a6)
 move.w  #88,LemCnt(a6)
 move.b  #1,LemCnt2(a6)
 bra     DLNext
DLShrugger:
 move.w  LemCnt(a6),d0
 tst.b   LemCnt2(a6)
 beq     DLS1
; raise shoulders
 addq.w  #1,d0
 cmp.w   #91,d0
 bne     DLS2
 clr.b   LemCnt2(a6)
 bra     DLS2
DLS1:
; lower shoulders
 subq.w  #1,d0
 cmp.w   #87,d0
 beq     DLWalk
DLS2:
 move.w  d0,LemCnt(a6)
 bra     DLNext



DLJumpIn:
 move.b  #11,LemAct+1(a6)
 move.w  #20,LemCnt(a6)
 addq.b  #1,LemsIn(a6)
 st      LLemTime(a5)
 bra     DLNext
DLJumpInner:
 move.w  LemCnt(a6),d0
 add.b   #1,d0
 cmp.b   #24,d0
 beq     DLOff
 move.w  d0,LemCnt(a6)
 bra     DLNext


 
DLBlock:
 move.b  #12,LemAct+1(a6)
 move.w  #92,LemCnt(a6)
 clr.b   LemCnt2(a6)
; mark one tile as blocking
 move.w  LemX(a6),d0
 move.w  LemY(a6),d1
 add.w   #7,d1
 move.b  #4,d2   ; blocking
 bsr     SetAttribAtXY
 bra     DLNext
DLBlocker:
 move.w  LemCnt(a6),d0
 tst.b   LemCnt2(a6)
 bne     DLBlAni1
 add.w   #1,d0
 cmp.w   #100,d0
 bne     DLBlAniEnd
 not.b   LemCnt2(a6)
 move.w  #96,d0
 bra     DLBlAniEnd
DLBlAni1:
 sub.w   #1,d0
 cmp.w   #91,d0
 bne     DLBlAniEnd
 not.b   LemCnt2(a6)
 move.b  #95,d0
DLBlAniEnd:
 move.w  d0,LemCnt(a6)
; test if Blocker looses ground
 move.w  LemX(a6),d0
 add.w   #1,d0
 add.w   LemDir(a6),d0
 move.w  LemY(a6),d1
 add.b   #16,d1
 bsr     TestDepth
 cmp.b   #3,d7
 beq     DLFall
 add.w   d7,LemY(a6)
 bra     DLNext


DLBomb:
 move.w	#100,LemCnt(a6)
; Faller(1), Floater(4) and Climber(7) explode without animation
 cmp.b	#1,LemAct+1(a6)
 beq	DLBoNoAni
 cmp.b	#4,LemAct+1(a6)
 beq	DLBoNoAni
 cmp.b	#7,LemAct+1(a6)
 beq	DLBoNoAni
 bra	DLBo1
DLBoNoAni:
 move.w	#108,LemCnt(a6)	; indicates no ani
DLBo1:
 move.b #13,LemAct+1(a6)
 bra	DLNext
DLBomber:
 cmp.w	#108,LemCnt(a6) ; do the actual bomb effect
 beq	DLBoBomb
 addq.w	#1,LemCnt(a6)
 cmp.w	#116,LemCnt(a6)
 beq	DLOff
 bra	DLNext
DLBoBomb:
 addq.w	#1,LemCnt(a6)
; erase those pixels: l=occupied by lemming
;0            ****    
;1          ********  
;2        ************
;3        ************  
;4      ****************
;5      ****************  
;6      ****llllllll****  
;7    ******llllllll******  
;8    ******llllllll******    
;9    ******llllllll******    
;a    ******llllllll******    
;b    ******llllllll******  
;c    ******llllllll******   
;d      ****llllllll****  
;e      ****************  
;f      ****************
;g        ************
;h        ************
;i          ********  
;j            ****    

;0
 move.w	LemX(a6),d0
 addq.w	#1,d0
 move.w	LemY(a6),d1
 addq.w #2,d1
 bsr	PixClear
 addq.w	#1,d0
 bsr	PixClear
;1
 subq.w	#2,d0
 addq.w	#1,d1
 bsr	PixClear4
;2
 addq.w	#1,d1
 subq.w	#1,d0
 bsr	PixClear4
 addq.w	#2,d0
 bsr	PixClear4
;3
 addq.w	#1,d1
 bsr	PixClear4
 subq.w	#2,d0
 bsr	PixClear4
;4
 addq.w	#1,d1
 subq.w	#1,d0
 bsr	PixClear8
;5
 addq.w	#1,d1
 bsr	PixClear8
;6
 addq.w	#1,d1
 bsr	PixClear8
;7
 addq.w	#1,d1
 subq.w	#1,d0
 bsr	PixClear4
 addq.w	#2,d0
 bsr	PixClear8
;8
 addq.w	#1,d1
 bsr	PixClear8
 subq.w	#2,d0
 bsr	PixClear4
;9
 addq.w	#1,d1
 bsr	PixClear4
 addq.w	#2,d0
 bsr	PixClear8
;a
 addq.w	#1,d1
 bsr	PixClear8
 subq.w	#2,d0
 bsr	PixClear4
;b
 addq.w	#1,d1
 bsr	PixClear4
 addq.w	#2,d0
 bsr	PixClear8
;c
 addq.w	#1,d1
 bsr	PixClear8
 subq.w	#2,d0
 bsr	PixClear4
;d
 addq.w	#1,d1
 addq.w	#1,d0
 bsr	PixClear8
;e
 addq.w	#1,d1
 bsr	PixClear8
;f
 addq.w	#1,d1
 bsr	PixClear8
;g
 addq.w	#1,d1
 addq.w	#1,d0
 bsr	PixClear4
 addq.w	#2,d0
 bsr	PixClear4
;h
 addq.w	#1,d1
 bsr	PixClear4
 subq.w	#2,d0
 bsr	PixClear4
;i
 addq.w	#1,d1
 addq.w	#1,d0
 bsr	PixClear4
;j
 addq.w	#1,d1
 addq.w	#1,d0
 bsr	PixClear
 addq.w	#1,d0
 bsr	PixClear
 bra	DLNext 


DLBash:
 move.w	#14,LemAct(a6)
 move.w	#116,LemCnt(a6)
 tst.w	LemDir(a6)
 bpl	DLNext
 add.w	#8,LemCnt(a6)
 bra	DLNext
DLBasher:
; check for commands
 move.b  GiveCommand(a6),d0
 cmp.b   LemCurrent(a6),d0
 bne     DLBaNoCmd
 bsr     DLCmdDig
 beq     DLDig
 bsr     DLCmdMine
 beq     DLMine
DLBaNoCmd:
; animate
 move.w  LemCnt(a6),d0
 add.b   #1,d0
 cmp.b   #116+8,d0
 beq     DLBaAniBack
 cmp.b   #124+8,d0
 bne     DLBaAniDo
DLBaAniBack:
 subq.b  #8,d0
DLBaAniDo:
 move.w  d0,LemCnt(a6)
; do bashing
 and.b   #7,d0
 cmp.b   #7,d0
 beq     DLBa1
 cmp.b   #0,d0
 beq     DLBa2
 cmp.b   #1,d0
 beq     DLBa3
 cmp.b   #2,d0
 beq     DLBa4
 cmp.b   #3,d0
 beq     DLBa5
 bra     DLNext
DLBa1:
 move.w  LemX(a6),d0
 move.w  LemY(a6),d1
 addq.w  #8,d1
 bsr     PixClear4
 add.w   LemDir(a6),d0
 addq.w  #1,d1
 bsr     PixClear4
 bra     DLNext
DLBa2:
 move.w  LemX(a6),d0
 add.w   LemDir(a6),d0
 add.w   LemDir(a6),d0
 move.w  LemY(a6),d1
 add.w   #10,d1
 bsr     PixClear4
 addq.w  #1,d1
 bsr     PixClear4
 bra     DLNext
DLBa3:
 move.w  LemX(a6),d0
 add.w   LemDir(a6),d0
 add.w   LemDir(a6),d0
 move.w  LemY(a6),d1
 add.w   #12,d1
 bsr     PixClear4
 addq.w  #1,d1
 bsr     PixClear4
 bra     DLNext
DLBa4:
 move.w  LemX(a6),d0
 add.w   LemDir(a6),d0
 move.w  LemY(a6),d1
 add.w   #14,d1
 bsr     PixClear4
 move.w  LemX(a6),d0
 addq.w  #1,d1
 bsr     PixClear4
 bra     DLNext
DLBa5:
 move.w  LemX(a6),d0
 subq.w  #1,d0
 tst.w   LemDir(a6)
 bmi     DLBaLeft
 addq.w  #5,d0
DLBaLeft:
 move.w  LemY(a6),d1
 add.w   #7,d1
 bsr     GetAttribAtXY
 cmp.b   #4,d2   ; blocking
 beq     DLBaRWalk
 add.w   #8,d1
 bsr     PixTest
 bne     DLBaDepth
 add.w   LemDir(a6),d0
 bsr     PixTest
 beq     DLWalk
DLBaDepth:
 add.w   #1,d1
 move.w  LemX(a6),d0
 add.w   #1,d0
 bsr     TestDepth
 tst.b   d7
 bne     DLWalk
 move.w  LemDir(a6),d0
 asl.w   #1,d0
 add.w   d0,LemX(a6)
 bra     DLNext
DLBaRWalk:
 neg.w   LemDir(a6)
 bra     DLWalk



DLOff:
 clr.w   LemAct(a6)
 clr.w   LemCnt(a6)
 subq.b  #1,LemsOut(a6)
 addq.b  #1,LemsOff(a6)
 bra     DLNext



; Climb is a buffered command
DLCmdClimb:
 cmp.b	#0,Command(a6)
 bne	DLCmdEnd
 btst.w	#8,LemAct(a6)
 bne	DLCmdEnd	; is already a climber
 tst.b  CmdClimb(a6)
 beq    DLCmdEnd
 sub.b  #1,CmdClimb(a6)
 bset.w	#8,LemAct(a6)
 rts

; Float is a buffered command
DLCmdFloat:
 cmp.b	#4,Command(a6)
 bne	DLCmdEnd
 btst.w	#9,LemAct(a6)
 bne	DLCmdEnd	; is already a floater
 tst.b  CmdFloat(a6)
 beq    DLCmdEnd
 sub.b  #1,CmdFloat(a6)
 bset.w	#9,LemAct(a6)
DLCmdEnd:
 rts

; regular commands
; usage: call the sub DLCmd<command>
; returns Z=1 if command is taken and decrements the command counter
; use beq DL<command> to execute the command afterwards
; returns Z=0 else
DLCmdBuild:
 cmp.b  #2,Command(a6)
 bne    DLCmdNo
 tst.b  CmdBuild(a6)
 beq    DLCmdNo
 sub.b  #1,CmdBuild(a6)
 bra    DLCmdYes

DLCmdMine:
 cmp.b  #3,Command(a6)
 bne    DLCmdNo
 tst.b  CmdMine(a6)
 beq    DLCmdNo
 sub.b  #1,CmdMine(a6)
 bra    DLCmdYes

DLCmdBomb:
 cmp.b  #1,Command(a6)
 bne    DLCmdNo
 tst.b  CmdBomb(a6)
 beq    DLCmdNo
 sub.b  #1,CmdBomb(a6)
 bra    DLCmdYes

DLCmdBlock:
 cmp.b  #5,Command(a6)
 bne    DLCmdNo
 tst.b  CmdStop(a6)
 beq    DLCmdNo
 sub.b  #1,CmdStop(a6)
 bra    DLCmdYes

DLCmdBash:
 cmp.b  #6,Command(a6)
 bne    DLCmdNo
 tst.b  CmdBash(a6)
 beq    DLCmdNo
 sub.b  #1,CmdBash(a6)
 bra    DLCmdYes

DLCmdDig:
 cmp.b  #7,Command(a6)
 bne    DLCmdNo
 tst.b  CmdDig(a6)
 beq    DLCmdNo
 sub.b  #1,CmdDig(a6)
 bra    DLCmdYes

; Z=0, cmd not taken
DLCmdNo:
 tst.b  LemsOut(a6)
 rts

; Z=1, cmd taken
DLCmdYes:
 cmp.b  d0,d0
 rts
 

 
DLNext:
 tst.w   LemAct(a6)
 beq     DLNoTarget
 move.w  LemX(a6),d0
 sub.w   XCrossTrue(a6),d0
 add.w   #3,d0
 cmp.w   #7,d0
 bcc     DLNoTarget
 move.w  LemY(a6),d0
 sub.w   YCrossTrue(a6),d0
 add.w   #14,d0
 cmp.w   #14,d0
 bcc     DLNoTarget
 move.b  LemCurrent(a6),LemTarget(a6)
DLNoTarget:
 move.w  LemAct(a6),0(a5)
 move.w  LemX(a6),2(a5)
 move.b  LemY+1(a6),5(a5)      ; @#
 move.w  LemCnt(a6),6(a5)
 move.w  LemDir(a6),8(a5)
 move.b  LemCnt2(a6),8(a5)   ; this is correct!
 lea     10(a5),a5
 add.b   #1,LemCurrent(a6)
 bra     DLLoop
DLEnd:
 tst.b   LemSpawn(a6)
 bne     DLEnd1
 move.b  LemSpawnInit(a6),LemSpawn(a6)
DLEnd1:
 rts

; PixTest
; in : d0.w X   out: Z=0 occupied
;      d1.w Y        Z=1 empty
PixTest:
 cmp.w	#4*LMAXCOLS,d0
 bcc	PixTestEnd
 cmp.w	#8*LMAXROWS,d1
 bcc	PixTestEnd
 movem.l d0-d2/a0-a1,-(sp)
 bsr     GetAttribAtXY
 cmp.b   #1,d2   ; 1-empty
 beq     PTEmpty
 cmp.b   #2,d2   ; 1-empty(exit)
 beq     PTEmpty
 move.l  hlplane0(a6),a0
 lea    lplane(a6),a1
;; move.l  hlplane1(a6),a1
 move.b  d0,d2
 and.b   #3,d2
 lsl.b   #1,d2
 mulu    #LMAXCOLS,d1
 lsr.w   #2,d0
 add.w   d1,d0
 move.b  0(a0,d0.w),d1
 or.b    0(a1,d0.w),d1
 lsl.b   d2,d1
 and.b   #$c0,d1
 movem.l (sp)+,d0-d2/a0-a1
 rts
PTEmpty:
 movem.l (sp)+,d0-d2/a0-a1
 cmp.w   d0,d0    ; set Z=1 (empty pixel)
 rts
PixTestEnd:
 cmp.w   d0,d0    ; set Z=1 (empty pixel)
 rts

; PixSetS (single)
; in : d0.w X in pixels(!)
;      d1.w Y
PixSetS:
 cmp.w	#8*LMAXCOLS,d0
 bcc	PixSetSEnd
 cmp.w	#8*LMAXROWS,d1
 bcc	PixSetSEnd
 movem.l d0-d3/a0-a1,-(sp)
 move.l  hlplane0(a6),a0
 lea    lplane(a6),a1
;; move.l  hlplane1(a6),a1
;; lea     8*LMAXROWS*LMAXCOLS(a0),a1

 move.b  d0,d2
 and.b   #7,d2
 mulu    #LMAXCOLS,d1
 lsr.w   #3,d0
 add.w   d1,d0
 move.b  #$80,d3
 lsr.b   d2,d3
 or.b    d3,0(a0,d0.w)
 or.b    d3,0(a1,d0.w)
 movem.l (sp)+,d0-d3/a0-a1
PixSetSEnd:
 rts
 
; PixClear
; in : d0.w X
;      d1.w Y

PixClear:
 movem.l d0-d3/a0-a1,-(sp)
 bsr     GetAttribAtXY
 cmp.b   #1,d2
 beq     PixClearEnd
 cmp.b   #2,d2
 beq     PixClearEnd
 cmp.b   #5,d2
 beq     PixClearEnd
 move.l  hlplane0(a6),a0
 lea    lplane(a6),a1
;; move.l  hlplane1(a6),a1
;; lea     8*LMAXROWS*LMAXCOLS(a0),a1

 move.b  d0,d2
 and.b   #3,d2
 lsl.b   #1,d2
 mulu    #LMAXCOLS,d1
 lsr.w   #2,d0
 add.w   d1,d0
 move.b  #$3f,d3
 ror.b   d2,d3
 and.b   d3,0(a0,d0.w)
 and.b   d3,0(a1,d0.w)
PixClearEnd:
 movem.l (sp)+,d0-d3/a0-a1
 rts

; PixClear4, clear 4 dpixels in a row
; in : d0.w X
;      d1.w Y

PixClear4:
 movem.l d0-d4/a0-a1,-(sp)
 move.l  hlplane0(a6),a0
 lea    lplane(a6),a1
;; move.l  hlplane1(a6),a1
;; lea     8*LMAXROWS*LMAXCOLS(a0),a1

 clr.b   d4
 bsr     GetAttribAtXY
 cmp.b   #1,d2
 beq     PixC4Next
 cmp.b   #2,d2
 beq     PixC4Next
 cmp.b   #5,d2
 beq     PixC4Next
 moveq.b #1,d4
PixC4Next:
 addq.w  #4,d0
 bsr     GetAttribAtXY
 cmp.b   #1,d2
 beq     PixC4Next2
 cmp.b   #2,d2
 beq     PixC4Next2
 cmp.b   #5,d2
 beq     PixC4Next2
 or.b    #2,d4
PixC4Next2:
 subq.w  #4,d0
 move.b  d0,d2
 and.b   #3,d2
 lsl.b   #1,d2
 mulu    #LMAXCOLS,d1
 lsr.w   #2,d0
 add.w   d1,d0
 move.b  #$ff,d3
 lsr.b   d2,d3
 not.b   d3

 ror.b   #1,d4
 bcc     PixC4Sec
 and.b   d3,0(a0,d0.w)
 and.b   d3,0(a1,d0.w)
PixC4Sec:
 ror.b   #1,d4
 bcc     PixC4End
 addq.w  #1,d0
 not.b   d3
 and.b   d3,0(a0,d0.w)
 and.b   d3,0(a1,d0.w)
PixC4End:
 movem.l (sp)+,d0-d4/a0-a1
 rts

PixClear8:
 bsr	PixClear4
 addq.w	#4,d0
 bsr	PixClear4
 subq.w	#4,d0
 rts

; GetAttribAtXY
; in : d0.w X in dpixels
;      d1.w Y in pixels
; out: d2.b attrib
GetAttribAtXY:
 cmp.w	#4*LMAXCOLS,d0
 bcc	GetAEnd
 cmp.w	#8*LMAXROWS,d1
 bcc	GetAEnd
 movem.l d0-d1/a0,-(sp)
 lea     AttribLevel(a6),a0
 lsr.w	#2,d0
 lsr.w	#3,d1
 mulu	#LMAXCOLS,d1
 add.w	d1,d0
 move.b	0(a0,d0.w),d2
 movem.l (sp)+,d0-d1/a0
 rts
GetAEnd:
 move.b #1,d2   ; empty
 rts

; SetAttribAtXY
; in : d0.w X in dpixels
;      d1.w Y in pixels
;      d2.b attrib
SetAttribAtXY:
 cmp.w	#4*LMAXCOLS,d0
 bcc	SetAEnd
 cmp.w	#8*LMAXROWS,d1
 bcc	SetAEnd
 movem.l d0-d1/a0,-(sp)
 lea     AttribLevel(a6),a0
 lsr.w	#2,d0
 lsr.w	#3,d1
 mulu	#LMAXCOLS,d1
 add.w	d1,d0
 move.b	d2,0(a0,d0.w)
 movem.l (sp)+,d0-d1/a0
SetAEnd:
 rts

; TestDepth
; in : do.w X   out: d7 Depth
;      d1.w Y
TestDepth:
 clr.w   d7
 bsr     PixTest
 bne     TDEnd
 add.w   #1,d0
 bsr     PixTest
 bne     TDEnd
 add.b   #1,d7
 add.b   #1,d1
 bsr     PixTest
 bne     TDEnd
 sub.w   #1,d0
 bsr     PixTest
 bne     TDEnd
 add.b   #1,d7
 add.b   #1,d1
 bsr     PixTest
 bne     TDEnd
 add.w   #1,d0
 bsr     PixTest
 bne     TDEnd
 add.b   #1,d7
TDEnd:
 rts

;; TestHeight
;; in : do.w X   out: d7 Height
;;      d1.w Y
;TestHeight:
; clr.w   d7
; bsr     PixTest
; bne     TH1
; add.w   #1,d0
; bsr     PixTest
; beq     THEnd
; bra     TH2
;TH1:
; add.w   #1,d0
;TH2:
; add.b   #1,d7
; sub.b   #1,d1
; bsr     PixTest
; bne     TH3
; sub.w   #1,d0
; bsr     PixTest
; beq     THEnd
; bra     TH4
;TH3:
; sub.w   #1,d0
;TH4:
; add.b   #1,d7
; sub.b   #1,d1
; bsr     PixTest
; bne     TH5
; add.w   #1,d0
; bsr     PixTest
; beq     THEnd
; bra     TH6
;TH5:
; add.w   #1,d0
;TH6:
; add.b   #1,d7
; sub.b   #1,d1
; bsr     PixTest
; bne     TH7
; sub.w   #1,d0
; bsr     PixTest
; beq     THEnd
;TH7:
; move.b  #$ff,d7
THEnd:
 rts

; TestHeight1, test only one column
; in : do.w X   out: d7 Height 0..4 or $ff(=too high)
;      d1.w Y
TestHeight1:
 clr.w   d7
 bsr     PixTest
 beq     THEnd
 add.b   #1,d7
 sub.b   #1,d1
 bsr     PixTest
 beq     THEnd
 add.b   #1,d7
 sub.b   #1,d1
 bsr     PixTest
 beq     THEnd
 add.b   #1,d7
 sub.b   #1,d1
 bsr     PixTest
 beq     THEnd
 add.b   #1,d7
 sub.b   #1,d1
 bsr     PixTest
 beq     THEnd
 move.b  #$ff,d7
 rts




; ****************************************************************************
; ****************************************************************************
;
; Screen Stuff
;
;
; ****************************************************************************
; ****************************************************************************

;
;  ShowScreen
;

ShowScreen:
        move.l  hlplane0(a6),a0
         lea    lplane(a6),a2
        ;;move.l  hlplane1(a6),a2
        ;;lea     8*LMAXROWS*LMAXCOLS(a0),a2

        move.l  plane0(a6),a1           ; ~32 +
        move.l  #LCD_MEM,a3             ; ~24
        move.w  Yoff(a6),d0             ; ~24
        mulu.w  #LMAXCOLS,d0            ; ~82
        add.w   Xoff(a6),d0             ; ~24
        add.l   d0,a0                   ; ~10
        add.l   d0,a2                   ; ~10
        moveq   #10,d1
        moveq   #LMAXCOLS-20,d2

        add.l   d1,a1
        add.l   d1,a3

        moveq   #127,d0 ; height        ; ~8
f5_l1:  
        move.l  (a0)+,(a1)+             ; ~40
        move.l  (a0)+,(a1)+             ; ~40
        move.l  (a0)+,(a1)+             ; ~40
        move.l  (a0)+,(a1)+             ; ~40
        move.l  (a0)+,(a1)+             ; ~40    ; add 1 more
        add.l   d1,a1                   ; ~12
        add.l   d2,a0                   ; ~12

        move.l  (a2)+,(a3)+             ; ~40
        move.l  (a2)+,(a3)+             ; ~40
        move.l  (a2)+,(a3)+             ; ~40
        move.l  (a2)+,(a3)+             ; ~40
        move.l  (a2)+,(a3)+             ; ~40    ; add 1 more
        add.l   d1,a3                   ; ~12
        add.l   d2,a2                   ; ~12 ; 128*(40*10+4*12)=57344 cycles

        dbf     d0,f5_l1                ; ~18*111+26
;; ShowCross
        move.l  #LCD_MEM,a0
        btst.b  #0,cnt(a6)
        beq     f5_l2
        move.l  plane0(a6),a0
f5_l2:  move.w  YCross(a6),d0
        mulu    #30,d0
        add.l   d0,a0

        move.w  XCross(a6),d0
        move.w  d0,d1
        lsr.w   #3,d0
        add.w   #10,d0
        add.l   d0,a0   ; position in the screen
        and.w   #7,d1

        ; d1 have shift value

        moveq   #7,d2
        lea     Cross(pc),a1
        tst.b   LemTarget(a6)
        bmi     f5_l4
        addq.l  #8,a1   ; Box
f5_l4:  clr.w   d0
        move.b  (a1)+,d0
        ror.w   d1,d0
        eor.b   d0,(a0)+
        ror.w   #8,d0
        eor.b   d0,(a0)+
        add.l   #28,a0
        dbf     d2,f5_l4
        rts

             
; *****************************************************************************
; SprDispInit
;
;

SprDispInit:
        clr.b   d7
        lea     SDLemTab(a6),a1
        lea     LemTab(a6),a0
SDILoop:
        tst.w   LLemAct(a0)
        bmi     SDIEnd
        beq     SDIOff
        move.w  LLemX(a0),d0
        lsr.w   #3,d0
        lsl.b   #1,d0
        sub.w   Xoff(a6),d0
        move.b  d0,SSDLemXc(a1) ; !
        cmp.b   #20,d0  ; changeable
        bcs     SDI1
        cmp.b   #-2,d0
        bcs     SDIOff
SDI1:
        move.w  LLemX(a0),d0
        and.b   #7,d0
        lsl.b   #1,d0
        move.b  d0,SSDLemXi(a1) ; !
        clr.w   d0
        move.b  LLemY(a0),d0            ; @#
        sub.w   Yoff(a6),d0
        move.b  #1,SSDLemPut(a1)
        move.b  d0,SSDLemY(a1) ; !
        bpl     SDINext
        cmp.b   #-15,d0
        bcc     SDINext
SDIOff:
        clr.b   SSDLemPut(a1)
SDINext:
        move.b  LLemCnt+1(a0),SSDLemCnt(a1)
        lea     10(a0),a0
        addq.l  #5,a1
        addq.b  #1,d7
        bra     SDILoop
SDIEnd:
        move.b  #$ff,(a1) ; end of list
        rts

; ****************************************************************
; SprDisp
;
;

SprDisp:
        lea     SDLemTab(a6),a5
        lea     LemTab(a6),a4
SDMainLoop:
        tst.b   SSDLemPut(a5)
        bmi     SDEnd
        beq     SDNext
        move.l  #LCD_MEM,a1
        move.l  plane0(a6),a0
        lea     nums(pc),a3
        lea     10(a0),a0
        lea     10(a1),a1
        ; number stuff
        clr.w   d0
        move.b  LLemTime(a4),d0
        bmi     SDCnt
        lsr.w   #2,d0
        addq.w  #1,d0                 ; skips the empty box
        lsl.w   #4,d0 ; /4*16         ; * number
        lea     0(a3,d0.w),a3         ; *
SDCnt:
        lea     WalkAnim(pc),a2
        clr.l   d0
        move.b  SSDLemCnt(a5),d0
        lsl.w   #5,d0
        add.l   d0,a2
        moveq   #16,d6 ; SDNumoflin
        move.l  #-1,d7 ; sdmask
        move.b  SSDLemY(a5),d0
SDTstUpper:
        cmp.b   #-15,d0
        bcs     SDTstLower
        add.b   #16,d0
        move.b  d0,d6
        clr.l   d1
        move.b  #16,d1
        sub.b   d0,d1
        add.l   d1,a2
        add.l   d1,a3           ; number
        bra     SDTstLeft

SDTstLower:
        clr.w   d1
        move.b  d0,d1
        cmp.b   #127-16,d0
        bls     SDCalcYAdr
        sub.b   #128,d0
        neg.b   d0
        move.b  d0,d6
SDCalcYAdr:
        mulu    #30,d1
        add.l   d1,a0
        add.l   d1,a1

SDTstLeft:
        move.b  SSDLemXc(a5),d0
        cmp.b   #-2,d0
        bcs     SDTstRight
        clr.w   d7
        swap    d7
;;        move.l  #$ffff,d7
        bra     SDCalcXAdr

SDTstRight:
        cmp.b   #18,d0
        bcs     SDCalcXAdr
        clr.w   d7
    ;;    move.l  #$ffff0000,d7
SDCalcXAdr:
        move.b  SSDLemXc(a5),d0
        ext.w   d0
        lea     0(a0,d0.w),a0
        lea     0(a1,d0.w),a1
SDPut:
        move.b  SSDLemXi(a5),d2
        clr.w   d1
        subq.b  #1,d6 ; sdnumoflins
SDLoop:
        clr.l   d3
        move.b  (a2)+,d3
        or.b    (a3),d3        ; number
        ror.l   #8,d3
        lsr.l   d2,d3
        and.l   d7,d3
        or.l    d3,(a0)
        clr.l   d3
        move.b  (a2)+,d3
        or.b    (a3)+,d3        ; number
        ror.l   #8,d3
        lsr.l   d2,d3
        and.l   d7,d3
        or.l    d3,(a1)
        lea     30(a0),a0
        lea     30(a1),a1
        dbra    d6,SDLoop
SDNext:
        addq.l  #5,a5
	lea     10(a4),a4
        bra     SDMainLoop
SDEnd:
        rts

InitInfo:                  ; only draws the boxes,
        moveq   #7,d7
f7_l1:  move.w  d7,d2
        bsr     cquad
        dbf     d7,f7_l1
        rts

qinfo:  dc.w    32*30
        dc.w    32*30+24*30
        dc.w    32*30+2*24*30
        dc.w    32*30+3*24*30
        dc.w    32*30+2
        dc.w    32*30+24*30+2
        dc.w    32*30+2*24*30+2
        dc.w    32*30+3*24*30+2

pquad:
        move.l  #LCD_MEM,a0
        move.l  plane0(a6),a1
        lea     quadsdta+2(pc),a2

        and.w   #7,d2
        lsl.w   #1,d2
        move.w  qinfo(pc,d2.w),d1
        lea     0(a0,d1.w),a0
        lea     0(a1,d1.w),a1   ; gets the quad pos
        lsl.w   #5,d2
        lea     0(a2,d2.w),a2
        moveq   #15,d2
f8_l1:  move.w  (a2)+,(a0)+    ; puts two quads cleared
        move.w  (a2)+,(a1)+
        lea     28(a0),a0
        lea     28(a1),a1
        dbf     d2,f8_l1
        rts

cquad:
        move.l  #LCD_MEM,a0
        move.l  plane0(a6),a1
        lea     quadsdta+2(pc),a2

        and.w   #7,d2
        lsl.w   #1,d2
        move.w  qinfo(pc,d2.w),d1
        lea     0(a0,d1.w),a0
        lea     0(a1,d1.w),a1   ; gets the quad pos
        lsl.w   #5,d2
        lea     0(a2,d2.w),a2
        moveq   #15,d2
f9_l1:  clr.w   (a0)+           ; puts two quads cleared
        move.w  (a2)+,d1
        or.w    (a2)+,d1
        move.w  d1,(a1)+
        lea     28(a0),a0
        lea     28(a1),a1
        dbf     d2,f9_l1
        rts

ShowTargetName:               ; 1@#
 clr.w   d7
 move.b  LemTarget(a6),d7
 bmi     STNNoTarget
 lsl.w   #1,d7   ; 12
 move.w  d7,d6   ; 8
 lsl.w   #2,d7   ; 14
 add.w   d6,d7   ; 8
 lea     LemTab(a6),a5
 move.w  0(a5,d7.w),d7
 btst.w  #8,d7
 beq     STN1
 btst.w  #9,d7
 beq     STN2
; 8 and 9 set -> athlete
 lea     NameTabAth(pc),a2
 bra     STNShow
STN1:
 btst.w  #9,d7
 beq     STNNoTarget
; 9 set -> Floater
 lea     NameTabFl(pc),a2
 bra     STNShow
STN2:
; 8 set -> Climber
 lea     NameTabCl(pc),a2
 bra     STNShow
STNNoTarget:
 lea     NameTab(pc),a2
 and.w   #15,d7 ; special case: only 8 entries
 lsl.b   #3,d7
 lea     0(a2,d7.w),a2
STNShow:
 move.w  #120,a1 ; y
 move.w  #0,a0  ; x
 bsr     putstr
 rts


; --------------------------------
;
;  Change contrast
;
; --------------------------------

;IncContrast:
; moveq   #9,d0
; trap    #9
; jsr     (a0)
; bra MainLoop
;DecContrast:
; moveq   #10,d0
; trap    #9
; jsr     (a0)
; bra MainLoop

; --------------------------------
;
;  Interrupt handler - counting interrups
;
; --------------------------------

int_1:
        movem.l d0/a0,-(a7)                                  ;
        move.l  mvar(pc),a0
        addq.w  #1,cnt(a0)
        move.w  cnt(a0),d0
        cmp.w   ntick(a0),d0
        bne     int_1_1
        ; tick
        move.b  #1,ticks(a0)
        add.w   #70,ntick(a0)
        addq.b  #1,ctick(a0)
        addq.w  #1,anit(a6)
int_1_1:
        cmp.b   #6,ctick(a0)
        bne     int_1_2
        clr.b   ctick(a0)
        subq.b  #1,time+1(a0)
        bpl     int_1_2
        move.b  #59,time+1(a0)
        subq.b  #1,time(a0)
        bpl     int_1_2
        move.b  #3,gstatus(a0)  ; time is up
int_1_2:
        move.w  nphase(a0),d0
        addq.w  #2,d0
        cmp.w   #6,d0
        bne     int_1_3
        clr.w   d0
int_1_3:
        move.w  table(a0,d0.w),($600010)                        ;  ~50
        move.w  d0,nphase(a0)
        movem.l (a7)+,d0/a0
        rte

; --------------------------------
;
;  Initialize grayscale and handles
;
; --------------------------------

initgr4lib:
        movem.l d0-d7/a0-a6,-(sp)
; memory allocation
;we need : LMAXROWS*LMAXCOLS*8 bytes (8000)
;
;
        move.l  #8*LMAXROWS*LMAXCOLS,-(sp)
	jsr	tios::HeapAlloc
        lea     4(a7),a7
	tst.w	d0
	beq	graylib_fail
        move.l  mvar(pc),a6
        move.w  d0,handle(a6)

        tios::DEREF d0,a0
        move.l  a0,hlplane0(a6)
        move.l  mvar(pc),d0
;        move.l  d0,d1
;        add.w   #2048,d1
;        move.l  d1,hlplane1(a6)
        add.w   #10055,d0
        lsr.l   #3,d0
        move.w  d0,table(a6)
        lsl.l   #3,d0
        move.l  d0,plane0(a6)
        move.l  #LCD_MEM,d0
        lsr.l   #3,d0
        move.w  d0,table+2(a6)
        move.w  d0,table+4(a6)
        clr.w   nphase(a6)
        clr.w   cnt(a6)
        clr.b   ctick(a6)
        move.w  #70,ntick(a6)
        move.w  #$0700,d0
	trap	#1
        move.l  $64,old_int_1(a6)
	bclr.b	#2,$600001
	move.l	#int_1,$64
	bset.b	#2,$600001
	trap	#1
        bsr ClearScreen
        move.w  #1,d1
graylib_fail:
        movem.l (sp)+,d0-d7/a0-a6
        rts

ClearScreen:
        movem.l d0-d1/a0-a1,-(a7)
        clr.l   d0
        move.l  #959,d1
        move.l  plane0(a6),a0
        move.l  #LCD_MEM,a1
RepClr:
        move.l  d0,(a0)+
        move.l  d0,(a1)+
        dbf     d1,RepClr
        movem.l (a7)+,d0-d1/a0-a1
        rts
 
; --------------------------------
;
;  Remove grayscale and handles
;
; --------------------------------

exitgr4lib:
        movem.l d0-d7/a0-a6,-(sp)
        move.w  #$0700,d0
	trap	#1
	bclr.b	#2,$600001
        move.l  old_int_1(a6),$64
	bset.b	#2,$600001
        trap    #1
        move.l  #LCD_MEM,d0
        lsr.l   #3,d0
        move.w  d0,($600010)

        move.w  handle(a6),-(sp)
	jsr	tios::HeapFree
        lea     2(a7),a7

        movem.l (sp)+,d0-d7/a0-a6
        rts


; ********************************************************
; Extracts the level from the tiles
; Initilizes all the variables related to the level
;
;

extractlvl:
        movem.l d0-d5/a0-a5,-(sp)
        lea     tiles(pc),a0
        move.l  hlplane0(a6),a1
         lea    lplane(a6),a2
        ;;;move.l  hlplane1(a6),a2
        lea     levels(pc),a3
        lea     AttribTab(pc),a4   ;attr
        move.l  mvar(pc),a5
        lea     AttribLevel(a5),a5
        move.w  curlvl(a6),d0

        mulu.w  #LMAXCOLS*LMAXROWS,d0
        add.l   d0,a3
	clr.w	d4	; count Y (for GaSpY)
        moveq   #LMAXROWS-1,d2  ; height
f4_l1:  moveq   #LMAXCOLS-1,d0  ; width
	clr.w	d3	; count X (for GaSpX)
f4_l2:  clr.w   d1
        move.b  (a3)+,d1
	move.b  0(a4,d1.w),d5	; attrib
	cmp.b	#3,d5	; spawn
	bne	f4_l21
	move.w	d3,GaSpX(a6)
	move.w	d4,GaSpY(a6)
	moveq.b	#1,d5	; empty
f4_l21:
	move.b	d5,(a5)+	; set the attrib for every tile
        lsl.w   #4,d1   ; ptr to tile inside the tile list
        move.b  0(a0,d1.w),(a1)+
        move.b  1(a0,d1.w),(a2)+
        move.b  2(a0,d1.w),LMAXCOLS-1(a1)
        move.b  3(a0,d1.w),LMAXCOLS-1(a2)
        move.b  4(a0,d1.w),2*LMAXCOLS-1(a1)
        move.b  5(a0,d1.w),2*LMAXCOLS-1(a2)
        move.b  6(a0,d1.w),3*LMAXCOLS-1(a1)
        move.b  7(a0,d1.w),3*LMAXCOLS-1(a2)
        move.b  8(a0,d1.w),4*LMAXCOLS-1(a1)
        move.b  9(a0,d1.w),4*LMAXCOLS-1(a2)
        move.b 10(a0,d1.w),5*LMAXCOLS-1(a1)
        move.b 11(a0,d1.w),5*LMAXCOLS-1(a2)
        move.b 12(a0,d1.w),6*LMAXCOLS-1(a1)
        move.b 13(a0,d1.w),6*LMAXCOLS-1(a2)
        move.b 14(a0,d1.w),7*LMAXCOLS-1(a1)
        move.b 15(a0,d1.w),7*LMAXCOLS-1(a2)
	addq.w	#1,d3
        dbf     d0,f4_l2
        add.l   #LMAXCOLS*7,a1
        add.l   #LMAXCOLS*7,a2
	addq.w	#1,d4
        dbf     d2,f4_l1
        movem.l (sp)+,d0-d5/a0-a5

; now we use the level data to initilize the variables
        lea     lvldta(pc),a3
        move.w  curlvl(a6),d0
        mulu    #LLVLDTA,d0
        add.l   d0,a3

; number of commands for this level

        move.b  LClimb(a3),CmdClimb(a6)
        move.b  LBomb(a3),CmdBomb(a6)
        move.b  #5,CmdBomb(a6)
        move.b  LBuild(a3),CmdBuild(a6)
        move.b  #5,CmdBuild(a6)
        move.b  LMine(a3),CmdMine(a6)
        move.b  #5,CmdMine(a6)
        move.b  LFloat(a3),CmdFloat(a6)
        move.b  LStop(a3),CmdStop(a6)
        move.b  #5,CmdStop(a6)
        move.b  LBash(a3),CmdBash(a6)
        move.b  LDig(a3),CmdDig(a6)

; count lemmings             ; @#

        move.b  LLemTot(a3),LemsTotal(a6)
        clr.b   LemsOut(a6)         ; actually out in the level
        clr.b   LemsIn(a6)          ; exited through the gate
        clr.b   LemsOff(a6)         ; exited or fallen off the level, bombed, ...
        move.b  LLemSp(a3),LemSpawnInit(a6)
        move.b  LLemSp(a3),LemSpawn(a6)

; if   LemsOff = LemsTotal
; then there are no more lemmings left
; and success can be checked
; Gates
;        move.w  LGaSpX(a3),GaSpX(a6)
;        move.w  LGaSpY(a3),GaSpY(a6)
;        move.w  LGaExX(a3),GaExX(a6)
;        move.w  LGaExY(a3),GaExY(a6)
;        clr.w   GaCntTr(a6)
;        clr.w   GaCntFl(a6)
;        clr.w   GaAniSp(a6)
        bsr     InitLemming

        move.w  #10,XCross(a6)
        move.w  #10,YCross(a6)

; Time left
        move.w  LTime(a3),time(a6)
	sf      Chain(a6)
; set Xoff to show start gate in the middle of the screen (if possible)
        move.w  GaSpX(a6),d0
	sub.w	#XMAXVIEW/16-2,d0   ; 2=<size of the gate(4)>/2
	bmi	f4_l3
	cmp.w	#LMAXCOLS-XMAXVIEW/8,d0
	bls	f4_l4
	; stick screen to right boundary
	move.w	#LMAXCOLS-XMAXVIEW/8,d0
	bra	f4_l4
f4_l3:
	; stick screen to left boundary
	clr.w	d0
f4_l4:
	and.w	#$fe,d0   ; Xoff is used in 2-byte steps
	move.w	d0,Xoff(a6)
        clr.w   Yoff(a6)
        clr.w   anit(a6)
        rts


; *************************
;
; a0,a1 : pos
; a2    : ptr a una asciiz
;
; a0 : X
; a1 : Y

putstr: movem.l d0/a0-a2,-(a7)
        clr.l   d0
        move.w  a1,d0
        lsl.w   #5,d0
        sub.w   a1,d0
        sub.w   a1,d0
        add.w   a0,d0
        move.l  #LCD_MEM,a0
        add.l   d0,a0           ; mem de video lista
                     
f1_l1:  clr.w   d0
        move.b  (a2)+,d0
        beq     f1_l10
        lea     charset(pc),a1
        sub.b   #48,d0  ; adjusted !
        lsl.w   #3,d0
        add.l   d0,a1

        move.b  (a1)+,(a0)
        lea     30(a0),a0
        move.b  (a1)+,(a0)
        lea     30(a0),a0
        move.b  (a1)+,(a0)
        lea     30(a0),a0
        move.b  (a1)+,(a0)
        lea     30(a0),a0
        move.b  (a1)+,(a0)
        lea     30(a0),a0
        move.b  (a1)+,(a0)
        lea     30(a0),a0
        move.b  (a1)+,(a0)
        lea     30(a0),a0
        move.b  (a1)+,(a0)
        lea     -209(a0),a0
        bra     f1_l1
f1_l10:
        movem.l (a7)+,d0/a0-a2
        rts

; ***************************************
; Prints out the variables like as time, lemms out, lems left
;
;
showvar:

        move.w  #0,a0
        move.w  a0,a1
        move.b  time(a6),d0
        lea     stime(pc),a2
        clr.w   d2
        bsr     putdec8a
        move.b  time+1(a6),d0
        addq.w  #3,a0
        bsr     putdec8aa
        move.w  #0,a0
        addq.l  #8,a1
        move.b  LemsOut(a6),d0
        lea     lout(pc),a2
        moveq   #6,d2
        bsr     putdec8a
        addq.l  #8,a1
        move.w  #0,a0
        move.b  LemsIn(a6),d0
        moveq   #6,d2
        lea     lin(pc),a2
        bsr     putdec8a

; now we put the amount of each command

        move.l  #LCD_MEM+26*30,a2
        lea     nums+16(pc),a3
        move.b  CmdClimb(a6),d0
        bsr     putdec
        move.b  CmdBomb(a6),d0
        bsr     putdec
        move.b  CmdBuild(a6),d0
        bsr     putdec
        move.b  CmdMine(a6),d0
        bsr     putdec
        move.l  #LCD_MEM+26*30+2,a2
        move.b  CmdFloat(a6),d0
        bsr     putdec
        move.b  CmdStop(a6),d0
        bsr     putdec
        move.b  CmdBash(a6),d0
        bsr     putdec
        move.b  CmdDig(a6),d0
        bsr     putdec
        rts

putdec: ext.w   d0
        ext.l   d0      ; to clear the high word
        move.l  a2,a0
        divu    #10,d0
        lsl.l   #4,d0
        move.w  d0,d1 ; decs
        swap    d0    ; units
        lea     0(a3,d1.w),a1
        lea     0(a3,d0.w),a4
        moveq   #5,d1
f11_l1: clr.w   d0
        move.b  (a1)+,d0
        lsl.w   #5,d0
        move.b  (a4)+,d0
        move.w  d0,(a0)
        lea     30(a0),a0
        dbf     d1,f11_l1
        lea     24*30(a2),a2
        rts       

; ***********************
;
; updates the animated tiles
;
updateani:

; updates the animated tiles
; animated tiles are tiles > 192
;
;

        lea     tiles(pc),a0
        move.l  hlplane0(a6),a1
         lea    lplane(a6),a2
        ;;;move.l  hlplane1(a6),a2

        lea     levels(pc),a3
        move.w  curlvl(a6),d0
        mulu.w  #LMAXCOLS*LMAXROWS,d0
        add.l   d0,a3
        
        moveq   #LMAXROWS-1,d2  ; height
f6_l1:  moveq   #LMAXCOLS-1,d0  ; width
f6_l2:  clr.w   d1
        move.w  anit(a6),d3
        move.b  (a3)+,d1 ; tile number
        cmp.b   #192,d1
        bcs     f6_l6
        cmp.b   #203,d1
        bcc     f6_l3
        ; animated gate
        cmp.w   #4,d3
        bcc     f6_l6   ; skips
f6_l3:  add.b   d1,d3
        and.w   #3,d3
        and.w   #$fffc,d1
        add.w   d1,d3
        lsl.w   #4,d3
        move.b  0(a0,d3.w),(a1)+
        move.b  1(a0,d3.w),(a2)+
        move.b  2(a0,d3.w),LMAXCOLS-1(a1)
        move.b  3(a0,d3.w),LMAXCOLS-1(a2)
        move.b  4(a0,d3.w),2*LMAXCOLS-1(a1)
        move.b  5(a0,d3.w),2*LMAXCOLS-1(a2)
        move.b  6(a0,d3.w),3*LMAXCOLS-1(a1)
        move.b  7(a0,d3.w),3*LMAXCOLS-1(a2)
        move.b  8(a0,d3.w),4*LMAXCOLS-1(a1)
        move.b  9(a0,d3.w),4*LMAXCOLS-1(a2)
        move.b 10(a0,d3.w),5*LMAXCOLS-1(a1)
        move.b 11(a0,d3.w),5*LMAXCOLS-1(a2)
        move.b 12(a0,d3.w),6*LMAXCOLS-1(a1)
        move.b 13(a0,d3.w),6*LMAXCOLS-1(a2)
        move.b 14(a0,d3.w),7*LMAXCOLS-1(a1)
        move.b 15(a0,d3.w),7*LMAXCOLS-1(a2)
f6_l4:  dbf     d0,f6_l2
        add.l   #LMAXCOLS*7,a1
        add.l   #LMAXCOLS*7,a2
        dbf     d2,f6_l1
        rts

f6_l6:  addq.l  #1,a1
        addq.l  #1,a2
        bra     f6_l4


; *******************
; returns key pressed (not when the key has been pressed)
;
; KeyStat : 0 : hand
;           1 : left
;           2 : up
;           3 : right
;           4   down
;           5
;           6 : ESC
;           7

; process pressed keys
; 1st. arrows

ScanKeys:
        move.l  #$600018,a0
        lea     3(a0),a1

        move.w  #%1111111111111110,(a0)
        asr.l   #8,d1       ; recovery
        move.b  (a1),d0     ; Arrows
        not.b   d0
        move.w  #%1111111011111111,(a0) ; ESC Key prep
        lsr.b   #3,d0
        move.b  d0,KeyStat(a6)
; process ESC Key
        move.b  (a1),d0
        move.w  #%1111111101111111,(a0) ; clear Key prep
        not.b   d0
        and.b   #%01000000,d0
        or.b    d0,KeyStat(a6)
; process clear Key
        move.b  (a1),d0
        not.b   d0
        and.b   #%00100000,d0
        or.b    d0,KeyStat(a6)
; process the FX

        move.w  #%1111111111111101,d0
        move.w  d0,(a0)
        clr.b   d2
        moveq   #8,d3
        lea     Fx(pc),a2
f10_l1:
        move.b  (a1),d1
        rol.w   #1,d0
        move.w  d0,(a0)
        and.b   #16,d1
        bne     f10_l2
        or.b    (a2),d2
f10_l2: addq.l  #1,a2
        dbf     d3,f10_l1
        move.b  d2,KeyStat+1(a6)
        rts     ; no keys
f10_l3: clr.b   KeyStat+1(a6)
        rts

; **************************************************************************
;
; Prelevel - screen
;
;

prescr:
        bsr     ClearScreen
        ; draws the minilvel 100x40 pixels

        move.l  #LCD_MEM,a0
        move.l  plane0(a6),a1
        move.l  hlplane0(a6),a2
         lea    lplane(a6),a3
        ;;;move.l  hlplane1(a6),a3
        lea     9(a0),a0
        lea     9(a1),a1

        moveq   #39,d0
f12_l1: moveq   #11,d1
f12_l2: moveq   #3,d5
        clr.b   d4
f12_l3: lsl.b   #2,d4
        move.b  (a2)+,d2
        move.b  d2,d3
        and.b   #$80,d2
        rol.b   #2,d2
        and.b   #$08,d3
        lsr.b   #3,d3
        or.b    d3,d2
        or.b    d2,d4
        dbra    d5,f12_l3
        move.b  d4,(a0)+
        moveq   #3,d5
        clr.b   d4
f12_l4: lsl.b   #2,d4
        move.b  (a3)+,d2
        move.b  d2,d3
        and.b   #$80,d2
        rol.b   #2,d2
        and.b   #$08,d3
        lsr.b   #3,d3
        or.b    d3,d2
        or.b    d2,d4
        dbra    d5,f12_l4
        move.b  d4,(a1)+

        dbra    d1,f12_l2
        lea     152(a2),a2
        lea     152(a3),a3
        lea     18(a0),a0
        lea     18(a1),a1
        dbra    d0,f12_l1

        lea     lvlmsg(pc),a2
        move.w  curlvl(a6),d0
        lsl.w   #4,d0
        lea     0(a2,d0.w),a2
        move.w  #7,a0
        move.w  #40,a1
        bsr     putstr
        
        lea     lvldta(pc),a4
        move.w  curlvl(a6),d7
        mulu    #LLVLDTA,d7
        clr.w   d0
        move.b  LLemTot(a4,d7.w),d0
        moveq   #12,d2
        lea     ltot(pc),a2
        move.w  #7,a0
        move.w  #50,a1
        bsr     putdec8a
        clr.w   d0
        move.b  LLemNe(a4,d7.w),d0
        moveq   #12,d2
        lea     lnee(pc),a2
        move.w  #7,a0
        move.w  #70,a1
        bsr     putdec8a
        move.w  #118,a1
        move.w  #5,a0
        lea     pressh(pc),a2
        bsr     putstr

f12_l5: bsr     ScanKeys
        btst    #0,KeyStat(a6)
        beq     f12_l5
        bsr     ClearScreen
        rts

; d0 : number
; d2 : string length
; a0 : X
; a1 : Y
; a2 : string
; destroys d0/d1/a0/a2/a3

putdec8a:
        bsr     putstr
putdec8aa:
        lea     decn(pc),a3
        ; d0 num
        clr.l   d1
        move.b  d0,d1
        divu    #10,d1  ; low quo/ hi rem
        add.b   #48,d1
        move.b  d1,(a3)
        swap    d1      ; rem low
        add.b   #48,d1
        move.b  d1,1(a3)
        add.w   d2,a0
        move.l  a3,a2
        bsr     putstr
        rts

IScaletab:
	dc.b	0,0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0,0
	dc.b	2,10,18,26,33,40,46,52
	dc.b	58,63,67,71,74,78,82,85
	dc.b	87,89,91,93,95,97,98,99
	dc.b	100,100,100,100,100,100,100,100
	dc.b	100,100,100,100,100,100,100,100
	dc.b	100,100,100,100,100,100,100,100
	dc.b	99,98,97,95,93,91,89,87
	dc.b	85,82,78,74,71,67,63,58
	dc.b	52,46,40,33,26,18,10,2
	dc.b	0,0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0,0
IScalepos:
	dc.w	0
Itext1:
                ;lemmings - a ti port by
	dc.b    'F?GGCHAM:V:;:NC:JILN:<R:',0
Itext2:
                ;   stephan effelsberg
	dc.b    ':::MN?JB;H:?@@?FM<?LA:::',0
Itext3:
                ; alejandro paz schmidt
	dc.b    ':;F?D;H>LI:J;S:M=BGC>N::',0
Itext4:
                ;f1..f8    select command
	dc.b    '@1UU@8::::M?F?=N:=IGG;H>',0
Itext5:
                ;hand        give command
	dc.b    'B;H>::::::::ACP?:=IGG;H>',0
Itext6:
                ; press esc to continue
	dc.b    ':JL?MM:?M=:NI:=IHNCHO?::',0
	even

Intro:
 bsr	ClearScreen
 bsr    putlem
Intromain:
 move.l hlplane0(a6),a0 ; instead of IBuf
 lea	Itext1(pc),a2
 bsr	Iputstr
 lea	24*8(a0),a0
 lea	Itext2(pc),a2
 bsr	Iputstr
 lea	24*8(a0),a0
 lea	Itext3(pc),a2
 bsr	Iputstr
 bsr	Introshow
 move.l hlplane0(a6),a0
 lea	Itext4(pc),a2
 bsr	Iputstr
 lea	24*8(a0),a0
 lea	Itext5(pc),a2
 bsr	Iputstr
 lea	24*8(a0),a0
 lea	Itext6(pc),a2
 bsr	Iputstr
 bsr	Introshow
; lem's background movement
 bra    Intromain
Imove:
 movem.w d0-d1,-(sp)
 move.w anit(a6),d0
 move.w lplane7(a6),d1
 and.b  #3,d0
 beq    pplane
 add.w  #480,d1
 cmp.b  #1,d0
 beq    pplane
 move.w plane0+2(a6),d1
 lsr.w  #3,d1
 cmp.b  #2,d0
 beq    pplane
 move.w lplane8(a6),d1
pplane:
 move.w d1,table(a6)
 movem.w (sp)+,d0-d1
 rts

Introshow:
 lea	IScalepos(pc),a3
 clr.w	(a3)
IScaleIn:
 bsr    Imove   ;;;;
 bsr    ScanKeys
 btst	#6,KeyStat(a6) ; ESC  => exit
 bne	Introend
 move.w	(a3),d0
 lea	IScaletab,a2
 lea	0(a2,d0.w),a2
 bsr	IScaler
 add.w	#1,(a3)
 cmp.w	#8*12,(a3)
 bls	IScaleIn
 rts
Introend:
 addq.l	#4,sp
 move.l plane0(a6),d0
 lsr.l  #3,d0
 move.w d0,table(a6)
 rts

IScaler:
 move.b	#24,d1
 move.l hlplane0(a6),a0
 move.l	#LCD_MEM,a1
 lea	240*6+2(a1),a1

scaleloop:
; scale 3 long words to the left of the middle
 swap	d1
 move.b	#99,d1
 move.w	#3*32-1,d0
 move.l	(a0)+,d2
 move.l	(a0)+,d3
 move.l	(a0)+,d4
 clr.l	d5
 clr.l	d6
 clr.l	d7
scaleloopl:
 sub.b	(a2),d1
 bpl	norotl
 add.b	#100,d1
 roxl.l	#1,d4
 roxl.l	#1,d3
 roxl.l	#1,d2
 roxl.l	#1,d7
 roxl.l	#1,d6
 roxl.l	#1,d5
 bra	scaleloopl1
norotl:
 roxl.l	#1,d4
 roxl.l	#1,d3
 roxl.l	#1,d2
scaleloopl1:
 dbra	d0,scaleloopl
 move.l	d5,(a1)+
 move.l	d6,(a1)+
 move.l	d7,(a1)+
; scale 3 long words to the right of the middle
 move.b	#99,d1
 move.w	#3*32-1,d0
 move.l	(a0)+,d2
 move.l	(a0)+,d3
 move.l	(a0)+,d4
 clr.l	d5
 clr.l	d6
 clr.l	d7
scaleloopr:
 sub.b	(a2),d1
 bpl	norotr
 add.b	#100,d1
 roxr.l	#1,d2
 roxr.l	#1,d3
 roxr.l	#1,d4
 roxr.l	#1,d5
 roxr.l	#1,d6
 roxr.l	#1,d7
 bra	scaleloopr1
norotr:
 roxr.l	#1,d2
 roxr.l	#1,d3
 roxr.l	#1,d4
scaleloopr1:
 dbra	d0,scaleloopr
 move.l	d5,(a1)+
 move.l	d6,(a1)+
 move.l	d7,(a1)+
; next line
 addq.l	#1,a2
 lea	6(a1),a1
 swap	d1
 sub.b	#1,d1
 bne	scaleloop
 rts

; in : a0 IBuf (+24*8 or +2*24*8)
;      a2 ptr to string
Iputstr:
        movem.l d0/a0-a2,-(a7)
                     
Iputstr1:
        clr.w   d0
        move.b  (a2)+,d0
        tst.b   d0
        beq     Iputstr2
        lea     charset(pc),a1
        sub.b   #48,d0  ; adjusted !
        lsl.w   #3,d0
	lea	0(a1,d0.w),a1

        move.b  (a1)+,(a0)
        move.b  (a1)+,24(a0)
        move.b  (a1)+,2*24(a0)
        move.b  (a1)+,3*24(a0)
        move.b  (a1)+,4*24(a0)
        move.b  (a1)+,5*24(a0)
        move.b  (a1)+,6*24(a0)
        move.b  (a1)+,7*24(a0)

        addq.l  #1,a0
        bra     Iputstr1
Iputstr2:
        movem.l (a7)+,d0/a0-a2
        rts
; d0 : comx
; d1 : comy
; d2 : finx  xerr
; d3 : finy  yerr
; d4 : t
;
; a0 : dx
; a1 : dy
; a2 : incx
; a3 : incy
; a4 : dist
; a5 : LCD_MEM


;line:   ; Bresenham's line algorythm
;        MOVE.L  #LCD_MEM,a5
;        movem.w d0-d7,-(sp)
;        move.w  d2,a0   ;finx,dx
;        sub.w   d0,a0   ;comx,dx
;        move.w  d3,a1   ;finy,dy
;        sub.w   d1,a1   ;comy,dy
;
;        clr.w   d2      ; xerr
;        clr.w   d3      ; yerr
;
;        move.w  #0,a2   ; incx
;        cmp.w   #0,a0   ; dx
;        beq     f25_l1
;        move.w  #1,a2   ; incx
;        bpl     f25_l1
;        move.w  #-1,a2  ;incx
;        clr.w   d7
;        sub     a0,d7   ;dx,d7
;        move    d7,a0   ;d7,dx
;f25_l1:
;        move.w  #0,a3   ;incy
;        cmp.w   #0,a1
;        beq     f25_l2
;        move.w  #30,a3  ;incy
;        bpl     f25_l2
;        move.w  #-30,a3 ;incy  ; -1
;        clr.w   d7
;        sub.w   a1,d7   ;dy,d7
;        move.w  d7,a1   ;d7,dy
;f25_l2:
;        move.w  a1,a4   ;dy,dist
;        cmp.w   a0,a1   ;dx,dy
;        bhi     f25_l3       ; dy > dx
;        move.w  a0,a4   ;dx,dist
;f25_l3:
;        move.w  a4,d4   ;dist,t
;        mulu    #30,d1  ;comy
;f25_l4:
;        move.w  d0,d7   ;comx,d7
;        move.b  d0,d6   ;comx,d6
;        and.b   #7,d6
;        lsr.w   #3,d7
;        add.w   d1,d7   ;comy,d7
;        move.b  #$80,d5
;        ror.b   d6,d5
;        or.b    d5,0(a5,d7.w)
;
;        add.w   a0,d2   ;dx,xerr
;        add.w   a1,d3   ;dy,yerr
;        cmp.w   a4,d2   ;dist,xerr
;        bhi     f25_l5
;        sub.w   a4,d2   ;dist,xerr
;        add.w   a2,d0   ;incx,comx
;f25_l5:
;        cmp.w   a4,d3   ;dist,yerr
;        bhi     f25_l6
;        sub.w   a4,d3   ;dist,yerr
;        add.w   a3,d1   ;incy,comy
;f25_l6: dbf     d4,f25_l4
;        movem.w (sp)+,d0-d7
;        rts

tupscr: bsr     ClearScreen

        move.w  #64,a1
        move.w  #9,a0
        cmp.w   #2,d0
        beq     f22_l2
        lea     timeup(pc),a2
        tst.w   d0
        beq     f22_l1
        lea     outofl(pc),a2
f22_l1: bsr     putstr
f22_l2: move.w  #118,a1
        move.w  #4,a0
        lea     presse(pc),a2
        bsr     putstr

f22_l5: bsr     ScanKeys
        btst    #6,KeyStat(a6)
        beq     f22_l5
        bsr     ClearScreen
        rts

pstr:   movem.l d0/a0/a2,-(a7)
        lea     0(a0,d0.w),a0   ; mem de video lista
        clr.w   d0

f23_l1: move.b  (a2)+,d0
        beq     f23_l10
        lea     charset(pc),a1
        sub.b   #48,d0  ; adjusted !
        lsl.w   #3,d0
        add.l   d0,a1
        moveq   #7,d1
f23_l2: move.b  (a1)+,(a0)
        lea     30(a0),a0
        dbf     d1,f23_l2
        lea     -239(a0),a0
        bra     f23_l1
f23_l10:
        movem.l (a7)+,d0/a0/a2
        rts

putlem: lea     lplane(a6),a0
        move.l  a0,d0
        move.w  #1999,d1
f24_l1: clr.l   (a0)+
        dbf     d1,f24_l1
        addq.l  #7,d0
        lsr.l   #3,d0
        move.w  d0,lplane7(a6)
        lsl.l   #3,d0
        move.l  d0,a0
        lea     lemmsg(pc),a2
        clr.l   d0
        move.w  #8*30,d0
        moveq   #7,d3
f24_l2: bsr     pstr
        add.w   #16*30,d0
        dbf     d3,f24_l2
        add.l   #3840,a0
        move.w  #6*30,d0
        moveq   #7,d3
f24_l3: bsr     pstr
        add.w   #16*30,d0
        dbf     d3,f24_l3
        move.l  plane0(a6),a0
        move.w  #4*30,d0
        moveq   #7,d3
f24_l4: bsr     pstr
        add.w   #16*30,d0
        dbf     d3,f24_l4
        move.l  hlplane0(a6),d0
        add.w   #2000,d0
        move.l  d0,a0
        move.w  #1000,d1
f24_l5: clr.l   (a0)+
        dbf     d1,f24_l5
        addq.w  #7,d0
        lsr.l   #3,d0
        move.w  d0,lplane8(a6)
        lsl.l   #3,d0
        move.l  d0,a0
        move.w  #2*30,d0
        moveq   #7,d3
f24_l6: bsr     pstr
        add.w   #16*30,d0
        dbf     d3,f24_l6
        rts

; --------------------------------
;
;  Variables & Constants
;
; --------------------------------
lemmsg  dc.b    'F?GGCHAM',0,0
                ;   just  dig
lvlmsg  dc.b    ':::DOMN::>CA:::',0 ; just dig
                ;  just  float
        dc.b    '::DOMN::@FI;N::',0 ; just float
        dc.b    ':::::::::::::::',0
        dc.b    ':::::::::::::::',0
        dc.b    ':::::::::::::::',0
                ;  time is up
timeup  dc.b    '::NCG?:CM::OJ::',0
                ;  out of lems
outofl  dc.b    '::ION:I@:F?GM::',0
                ;press esc to start over
presse  dc.b    'JL?MM:?M=:NI:MN;LN:IP?L',0
                ;press hand to begin
pressh  dc.b    'JL?MM:B;H>:NI:<?ACH',0
                ;total lems
ltot    dc.b    'NIN;F:F?GM',0,0
                ;lems needed
lnee    dc.b    'F?GM:H??>?>',0

stime      dc.b    '::W::',0
lin        dc.b    'CH',0,0
lout       dc.b    'ION',0

NameTab dc.b 58,58,58,58,58,58,58,0 ; 0 empty
        dc.b 64,59,70,70,63,76,58,0 ; 1 Faller
        dc.b 81,59,70,69,63,76,58,0 ; 2 Walker
        dc.b 62,67,65,65,63,76,58,0 ; 3 Digger
        dc.b 64,70,73,59,78,63,76,0 ; 4 Floater
        dc.b 64,70,73,59,78,63,76,0 ; 5 Floater(Lander)
        dc.b 58,58,58,58,58,58,58,0 ; 6 empty(Splasher)
        dc.b 61,70,67,71,60,63,76,0 ; 7 Climber
        dc.b 71,67,72,63,76,58,58,0 ; 8 Miner
        dc.b 60,79,67,70,62,63,76,0 ; 9 Builder
        dc.b 60,79,67,70,62,63,76,0 ; 10 Builder(Shrugger)
        dc.b 58,58,58,58,58,58,58,0 ; 11 empty
        dc.b 60,70,73,61,69,63,76,0 ; 12 Blocker
        dc.b 60,73,71,69,63,76,58,0 ; 13 Bomber
        dc.b 58,58,58,58,58,58,58,0 ; 14 empty
        dc.b 58,58,58,58,58,58,58,0 ; 15 empty
NameTabAth:
        dc.b 59,78,66,70,63,78,63,0 ; Athlete
NameTabCl:
        dc.b 61,70,67,71,60,63,76,0 ; Climber
NameTabFl:
        dc.b 64,70,73,59,78,63,76,0 ; Floater
       
        even

decn    dc.b    0,0,0,0

;hexa    dc.b    '0123456789;<=>?@'

Cross:
 dc.b %00011000
 dc.b %00011000
 dc.b %00000000
 dc.b %11000011
 dc.b %11000011
 dc.b %00000000
 dc.b %00011000
 dc.b %00011000
Box:
 dc.b %11000011
 dc.b %10000001
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %10000001
 dc.b %11000011

Fx      dc.b    128,4,64,2,32,1,16,0,8,0
                
_comment     dc.b "Lemmings v0.3.3.5",0

 end

